package cn.iocoder.yudao.module.system.dal.mysql.permission;

import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.module.system.controller.admin.permission.vo.menu.MenuListReqVO;
import cn.iocoder.yudao.module.system.controller.admin.permission.vo.menu.MenuRespVO;
import cn.iocoder.yudao.module.system.controller.admin.permission.vo.menu.MenuSaveVO;
import cn.iocoder.yudao.module.system.dal.dataobject.permission.MenuDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

@Mapper
public interface MenuMapper extends BaseMapperX<MenuDO> {

    @TenantIgnore
    default MenuDO selectByParentIdAndName(Long parentId, String name) {
        return selectOne(MenuDO::getParentId, parentId, MenuDO::getName, name);
    }

    @TenantIgnore
    default Long selectCountByParentId(Long parentId) {
        return selectCount(MenuDO::getParentId, parentId);
    }

    @TenantIgnore
    default List<MenuDO> selectList(MenuListReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<MenuDO>()
                .likeIfPresent(MenuDO::getName, reqVO.getName())
                .eqIfPresent(MenuDO::getStatus, reqVO.getStatus())
                .eqIfPresent(MenuDO::getParentId, reqVO.getParentId()));
    }

    @TenantIgnore
    default List<MenuDO> selectListByPermission(String permission) {
        return selectList(MenuDO::getPermission, permission);
    }

    @TenantIgnore
    List<MenuRespVO> getTenantMenus(@Param("reqVO") MenuListReqVO reqVO);

    @TenantIgnore
    default MenuDO getMenuById(Long menuId) {
        return selectOne(MenuDO::getId, menuId);
    }

    @TenantIgnore
    default List<MenuDO> getMenuListByIds(Collection<Long> ids) {
        return selectBatchIds(ids);
    }

//    @TenantIgnore
//    default Long updateMenuById(MenuSaveVO updateReqVO) {
//        return updateById(updateReqVO);
//    }

}
